pcl::PointCloud< PointT > Class Template Reference

PointCloud represents the base class in PCL for storing collections of 3D points. More...

`#include <pcl/point_cloud.h>`

## Public Types

using | PointType = PointT
using | VectorType = std::vector< PointT, Eigen::aligned_allocator< PointT > >
using | CloudVectorType = std::vector< PointCloud< PointT >, Eigen::aligned_allocator< PointCloud< PointT > > >
using | Ptr = shared_ptr< PointCloud< PointT > >
using | ConstPtr = shared_ptr< const PointCloud< PointT > >
using | value_type = PointT
using | reference = PointT &
using | const_reference = const PointT &
using | difference_type = typename VectorType::difference_type
using | size_type = typename VectorType::size_type
using | iterator = typename VectorType::iterator
using | const_iterator = typename VectorType::const_iterator
using | reverse_iterator = typename VectorType::reverse_iterator
using | const_reverse_iterator = typename VectorType::const_reverse_iterator

## Public Member Functions

| PointCloud ()=default
| Default constructor. More...
| PointCloud (const PointCloud< PointT > &pc, const Indices &indices)
| Copy constructor from point cloud subset. More...
| PointCloud (std::uint32_t width_, std::uint32_t height_, const PointT &value_=PointT())
| Allocate constructor from point cloud subset. More...
PointCloud & | operator+= (const PointCloud &rhs)
| Add a point cloud to the current cloud. More...
PointCloud | operator+ (const PointCloud &rhs)
| Add a point cloud to another cloud. More...
const PointT & | at (int column, int row) const
| Obtain the point given by the (column, row) coordinates. More...
PointT & | at (int column, int row)
| Obtain the point given by the (column, row) coordinates. More...
const PointT & | operator() (std::size_t column, std::size_t row) const
| Obtain the point given by the (column, row) coordinates. More...
PointT & | operator() (std::size_t column, std::size_t row)
| Obtain the point given by the (column, row) coordinates. More...
bool | isOrganized () const
| Return whether a dataset is organized (e.g., arranged in a structured grid). More...
Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap (int dim, int stride, int offset)
| Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud. More...
const Eigen::Map< const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap (int dim, int stride, int offset) const
| Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud. More...
Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap ()
const Eigen::Map< const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > | getMatrixXfMap () const
iterator | begin () noexcept
iterator | end () noexcept
const_iterator | begin () const noexcept
const_iterator | end () const noexcept
const_iterator | cbegin () const noexcept
const_iterator | cend () const noexcept
reverse_iterator | rbegin () noexcept
reverse_iterator | rend () noexcept
const_reverse_iterator | rbegin () const noexcept
const_reverse_iterator | rend () const noexcept
const_reverse_iterator | crbegin () const noexcept
const_reverse_iterator | crend () const noexcept
std::size_t | size () const
index_t | max_size () const noexcept
void | reserve (std::size_t n)
bool | empty () const
PointT * | data () noexcept
const PointT * | data () const noexcept
void | resize (std::size_t count)
| Resizes the container to contain `count` elements. More...
void | resize (uindex_t new_width, uindex_t new_height)
| Resizes the container to contain `new_width * new_height` elements. More...
void | resize (index_t count, const PointT &value)
| Resizes the container to contain count elements. More...
void | resize (index_t new_width, index_t new_height, const PointT &value)
| Resizes the container to contain count elements. More...
const PointT & | operator[] (std::size_t n) const
PointT & | operator[] (std::size_t n)
const PointT & | at (std::size_t n) const
PointT & | at (std::size_t n)
const PointT & | front () const
PointT & | front ()
const PointT & | back () const
PointT & | back ()
void | assign (index_t count, const PointT &value)
| Replaces the points with `count` copies of `value` More...
void | assign (index_t new_width, index_t new_height, const PointT &value)
| Replaces the points with `new_width * new_height` copies of `value` More...
template<class InputIterator >
void | assign (InputIterator first, InputIterator last)
| Replaces the points with copies of those in the range `[first, last)` More...
template<class InputIterator >
void | assign (InputIterator first, InputIterator last, index_t new_width)
| Replaces the points with copies of those in the range `[first, last)` More...
void | assign (std::initializer_list< PointT > ilist)
| Replaces the points with the elements from the initializer list `ilist` More...
void | assign (std::initializer_list< PointT > ilist, index_t new_width)
| Replaces the points with the elements from the initializer list `ilist` More...
void | push_back (const PointT &pt)
| Insert a new point in the cloud, at the end of the container. More...
void | transient_push_back (const PointT &pt)
| Insert a new point in the cloud, at the end of the container. More...
template<class... Args>
reference | emplace_back (Args &&...args)
| Emplace a new point in the cloud, at the end of the container. More...
template<class... Args>
reference | transient_emplace_back (Args &&...args)
| Emplace a new point in the cloud, at the end of the container. More...
iterator | insert (iterator position, const PointT &pt)
| Insert a new point in the cloud, given an iterator. More...
iterator | transient_insert (iterator position, const PointT &pt)
| Insert a new point in the cloud, given an iterator. More...
void | insert (iterator position, std::size_t n, const PointT &pt)
| Insert a new point in the cloud N times, given an iterator. More...
void | transient_insert (iterator position, std::size_t n, const PointT &pt)
| Insert a new point in the cloud N times, given an iterator. More...
template<class InputIterator >
void | insert (iterator position, InputIterator first, InputIterator last)
| Insert a new range of points in the cloud, at a certain position. More...
template<class InputIterator >
void | transient_insert (iterator position, InputIterator first, InputIterator last)
| Insert a new range of points in the cloud, at a certain position. More...
template<class... Args>
iterator | emplace (iterator position, Args &&...args)
| Emplace a new point in the cloud, given an iterator. More...
template<class... Args>
iterator | transient_emplace (iterator position, Args &&...args)
| Emplace a new point in the cloud, given an iterator. More...
iterator | erase (iterator position)
| Erase a point in the cloud. More...
iterator | transient_erase (iterator position)
| Erase a point in the cloud. More...
iterator | erase (iterator first, iterator last)
| Erase a set of points given by a (first, last) iterator pair. More...
iterator | transient_erase (iterator first, iterator last)
| Erase a set of points given by a (first, last) iterator pair. More...
void | swap (PointCloud< PointT > &rhs)
| Swap a point cloud with another cloud. More...
void | clear ()
| Removes all points in a cloud and sets the width and height to 0. More...
Ptr | makeShared () const
| Copy the cloud to the heap and return a smart pointer Note that deep copy is performed, so avoid using this function on non-empty clouds. More...

## Static Public Member Functions

static bool | concatenate (pcl::PointCloud< PointT > &cloud1, const pcl::PointCloud< PointT > &cloud2)
static bool | concatenate (const pcl::PointCloud< PointT > &cloud1, const pcl::PointCloud< PointT > &cloud2, pcl::PointCloud< PointT > &cloud_out)

## Public Attributes

pcl::PCLHeader | header
| The point cloud header. More...
std::vector< PointT, Eigen::aligned_allocator< PointT > > | points
| The point data. More...
std::uint32_t | width = 0
| The point cloud width (if organized as an image-structure). More...
std::uint32_t | height = 0
| The point cloud height (if organized as an image-structure). More...
bool | is_dense = true
| True if no points are invalid (e.g., have NaN or Inf values in any of their floating point fields). More...
Eigen::Vector4f | sensor_origin_ = Eigen::Vector4f::Zero ()
| Sensor acquisition pose (origin/translation). More...
Eigen::Quaternionf | sensor_orientation_ = Eigen::Quaternionf::Identity ()
| Sensor acquisition pose (rotation). More...

## Detailed Description

### template<typename PointT>
class pcl::PointCloud< PointT >

PointCloud represents the base class in PCL for storing collections of 3D points.

The class is templated, which means you need to specify the type of data that it should contain. For example, to create a point cloud that holds 4 random XYZ data points, use:

pcl::PointCloud<pcl::PointXYZ> cloud;
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
cloud.push_back (pcl::PointXYZ (rand (), rand (), rand ()));
pcl::PointCloud< pcl::PointXYZ >
pcl::PointCloud::push_back
void push_back(const PointT &pt)
Insert a new point in the cloud, at the end of the container.
Definition: point_cloud.h:652
pcl::PointXYZ
A point structure representing Euclidean xyz coordinates.
Definition: point_types.hpp:347

The PointCloud class contains the following elements:

- width - specifies the width of the point cloud dataset in the number of points. WIDTH has two meanings:
  - it can specify the total number of points in the cloud (equal with POINTS see below) for unorganized datasets;
  - it can specify the width (total number of points in a row) of an organized point cloud dataset. Mandatory.
- height - specifies the height of the point cloud dataset in the number of points. HEIGHT has two meanings:
  - it can specify the height (total number of rows) of an organized point cloud dataset;
  - it is set to 1 for unorganized datasets (thus used to check whether a dataset is organized or not). Mandatory.
- points - the data array where all points of type PointT are stored. Mandatory.
- is_dense - specifies if all the data in points is finite (true), or whether it might contain Inf/NaN values (false). Mandatory.
- sensor_origin_ - specifies the sensor acquisition pose (origin/translation). Optional.
- sensor_orientation_ - specifies the sensor acquisition pose (rotation). Optional.

Author
  Patrick Mihelich, Radu B. Rusu

Definition at line 172 of file point_cloud.h.

## Member Typedef Documentation

## CloudVectorType

template<typename PointT >

using pcl::PointCloud< PointT >::CloudVectorType = std::vector<PointCloud<PointT>, Eigen::aligned_allocator<PointCloud<PointT> > >

Definition at line 412 of file point_cloud.h.

## const_iterator

template<typename PointT >

using pcl::PointCloud< PointT >::const_iterator = typename VectorType::const_iterator

Definition at line 426 of file point_cloud.h.

## const_reference

template<typename PointT >

using pcl::PointCloud< PointT >::const_reference = const PointT&

Definition at line 420 of file point_cloud.h.

## const_reverse_iterator

template<typename PointT >

using pcl::PointCloud< PointT >::const_reverse_iterator = typename VectorType::const_reverse_iterator

Definition at line 428 of file point_cloud.h.

## ConstPtr

template<typename PointT >

using pcl::PointCloud< PointT >::ConstPtr = shared_ptr<const PointCloud<PointT> >

Definition at line 414 of file point_cloud.h.

## difference_type

template<typename PointT >

using pcl::PointCloud< PointT >::difference_type = typename VectorType::difference_type

Definition at line 421 of file point_cloud.h.

## iterator

template<typename PointT >

using pcl::PointCloud< PointT >::iterator = typename VectorType::iterator

Definition at line 425 of file point_cloud.h.

## PointType

template<typename PointT >

using pcl::PointCloud< PointT >::PointType = PointT

Definition at line 410 of file point_cloud.h.

## Ptr

template<typename PointT >

using pcl::PointCloud< PointT >::Ptr = shared_ptr<PointCloud<PointT> >

Definition at line 413 of file point_cloud.h.

## reference

template<typename PointT >

using pcl::PointCloud< PointT >::reference = PointT&

Definition at line 419 of file point_cloud.h.

## reverse_iterator

template<typename PointT >

using pcl::PointCloud< PointT >::reverse_iterator = typename VectorType::reverse_iterator

Definition at line 427 of file point_cloud.h.

## size_type

template<typename PointT >

using pcl::PointCloud< PointT >::size_type = typename VectorType::size_type

Definition at line 422 of file point_cloud.h.

## value_type

template<typename PointT >

using pcl::PointCloud< PointT >::value_type = PointT

Definition at line 418 of file point_cloud.h.

## VectorType

template<typename PointT >

using pcl::PointCloud< PointT >::VectorType = std::vector<PointT, Eigen::aligned_allocator<PointT> >

Definition at line 411 of file point_cloud.h.

## Constructor & Destructor Documentation

## PointCloud() [1/3]

template<typename PointT >

pcl::PointCloud< PointT >::PointCloud | ( |  | ) |

default

Default constructor.

Sets is_dense to true, width and height to 0, and the sensor_origin_ and sensor_orientation_ to identity.

## PointCloud() [2/3]

template<typename PointT >

pcl::PointCloud< PointT >::PointCloud | ( | const PointCloud< PointT > & | pc,
|  | const Indices & | indices
| ) |  |

inline

Copy constructor from point cloud subset.

Parameters

  [in] | pc | the cloud to copy into this
  [in] | indices | the subset to copy

Definition at line 185 of file point_cloud.h.

References pcl::PointCloud< PointT >::size().

## PointCloud() [3/3]

template<typename PointT >

pcl::PointCloud< PointT >::PointCloud | ( | std::uint32_t | width_,
|  | std::uint32_t | height_,
|  | const PointT & | value_ = `PointT ()`
| ) |  |

inline

Allocate constructor from point cloud subset.

Parameters

  [in] | width_ | the cloud width
  [in] | height_ | the cloud height
  [in] | value_ | default value

Definition at line 201 of file point_cloud.h.

## Member Function Documentation

## assign() [1/6]

template<typename PointT >

void pcl::PointCloud< PointT >::assign | ( | index_t | count,
|  | const PointT & | value
| ) |  |

inline

Replaces the points with `count` copies of `value`

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | count | new size of the point cloud
  [in] | value | value each point of the cloud should have

Definition at line 548 of file point_cloud.h.

Referenced by pcl::transformPointCloud(), and pcl::transformPointCloudWithNormals().

## assign() [2/6]

template<typename PointT >

void pcl::PointCloud< PointT >::assign | ( | index_t | new_width,
|  | index_t | new_height,
|  | const PointT & | value
| ) |  |

inline

Replaces the points with `new_width * new_height` copies of `value`

Parameters

  [in] | new_width | new width of the point cloud
  [in] | new_height | new height of the point cloud
  [in] | value | value each point of the cloud should have

Definition at line 562 of file point_cloud.h.

## assign() [3/6]

template<typename PointT >
template<class InputIterator >

void pcl::PointCloud< PointT >::assign | ( | InputIterator | first,
|  | InputIterator | last
| ) |  |

inline

Replaces the points with copies of those in the range `[first, last)`

The behavior is undefined if either argument is an iterator into `*this`

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Definition at line 578 of file point_cloud.h.

## assign() [4/6]

template<typename PointT >
template<class InputIterator >

void pcl::PointCloud< PointT >::assign | ( | InputIterator | first,
|  | InputIterator | last,
|  | index_t | new_width
| ) |  |

inline

Replaces the points with copies of those in the range `[first, last)`

The behavior is undefined if either argument is an iterator into `*this`

Note
  This calculates the height based on size and width provided. This means the assignment happens even if the size is not perfectly divisible by width

Parameters

  [in] | first,last | the range from which the points are copied
  [in] | new_width | new width of the point cloud

Definition at line 596 of file point_cloud.h.

## assign() [5/6]

template<typename PointT >

void pcl::PointCloud< PointT >::assign | ( | std::initializer_list< PointT > | ilist | ) |

inline

Replaces the points with the elements from the initializer list `ilist`

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Definition at line 617 of file point_cloud.h.

## assign() [6/6]

template<typename PointT >

void pcl::PointCloud< PointT >::assign | ( | std::initializer_list< PointT > | ilist,
|  | index_t | new_width
| ) |  |

inline

Replaces the points with the elements from the initializer list `ilist`

Note
  This calculates the height based on size and width provided. This means the assignment happens even if the size is not perfectly divisible by width

Parameters

  [in] | ilist | initializer list from which the points are copied
  [in] | new_width | new width of the point cloud

Definition at line 632 of file point_cloud.h.

## at() [1/4]

template<typename PointT >

PointT& pcl::PointCloud< PointT >::at | ( | int | column,
|  | int | row
| ) |  |

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 276 of file point_cloud.h.

## at() [2/4]

template<typename PointT >

const PointT& pcl::PointCloud< PointT >::at | ( | int | column,
|  | int | row
| ) |  | const

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 262 of file point_cloud.h.

Referenced by pcl::FastBilateralFilterOMP< PointT >::applyFilter(), pcl::filters::Pyramid< PointT >::compute(), pcl::occlusion_reasoning::filter(), pcl::occlusion_reasoning::getOccludedCloud(), and pcl::PointCloudDepthAndRGBtoXYZRGBA().

## at() [3/4]

template<typename PointT >

PointT& pcl::PointCloud< PointT >::at | ( | std::size_t | n | ) |

inline

Definition at line 534 of file point_cloud.h.

## at() [4/4]

template<typename PointT >

const PointT& pcl::PointCloud< PointT >::at | ( | std::size_t | n | ) | const

inline

Definition at line 533 of file point_cloud.h.

## back() [1/2]

template<typename PointT >

PointT& pcl::PointCloud< PointT >::back | ( |  | ) |

inline

Definition at line 538 of file point_cloud.h.

## back() [2/2]

template<typename PointT >

const PointT& pcl::PointCloud< PointT >::back | ( |  | ) | const

inline

Definition at line 537 of file point_cloud.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getEdgeIndex(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getFaceIndex(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getHalfEdgeIndex(), and pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getVertexIndex().

## begin() [1/2]

template<typename PointT >

const_iterator pcl::PointCloud< PointT >::begin | ( |  | ) | const

inline noexcept

Definition at line 431 of file point_cloud.h.

## begin() [2/2]

template<typename PointT >

iterator pcl::PointCloud< PointT >::begin | ( |  | ) |

inline noexcept

Definition at line 429 of file point_cloud.h.

Referenced by pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::cleanUp(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::computeCovariances(), pcl::PointCloud< PointT >::concatenate(), pcl::common::deleteCols(), pcl::common::deleteRows(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::extractDescriptors(), pcl::getFeaturePointCloud(), pcl::SupervoxelClustering< PointT >::getLabeledCloud(), pcl::SupervoxelClustering< PointT >::getLabeledVoxelCloud(), pcl::SupervoxelClustering< PointT >::makeSupervoxelNormalCloud(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), and pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::validateTransformation().

## cbegin()

template<typename PointT >

const_iterator pcl::PointCloud< PointT >::cbegin | ( |  | ) | const

inline noexcept

Definition at line 433 of file point_cloud.h.

Referenced by pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::readRange(), pcl::MinCutSegmentation< PointT >::setBackgroundPoints(), and pcl::MinCutSegmentation< PointT >::setForegroundPoints().

## cend()

template<typename PointT >

const_iterator pcl::PointCloud< PointT >::cend | ( |  | ) | const

inline noexcept

Definition at line 434 of file point_cloud.h.

Referenced by pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::readRange(), pcl::MinCutSegmentation< PointT >::setBackgroundPoints(), and pcl::MinCutSegmentation< PointT >::setForegroundPoints().

## clear()

template<typename PointT >

void pcl::PointCloud< PointT >::clear | ( |  | ) |

inline

Removes all points in a cloud and sets the width and height to 0.

Definition at line 874 of file point_cloud.h.

Referenced by pcl::GridMinimum< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::ProjectInliers< PointT >::applyFilter(), pcl::UniformSampling< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::approximatePolygon2D(), pcl::DisparityMapConverter< PointT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::TSDFVolume< VoxelT, WeightT >::convertToTsdfCloud(), pcl::copyPointCloud(), pcl::gpu::extractEuclideanClusters(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::SegmentDifferences< PointT >::segment(), and pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::setSearchSurface().

## concatenate() [1/2]

template<typename PointT >

static bool pcl::PointCloud< PointT >::concatenate | ( | const pcl::PointCloud< PointT > & | cloud1,
|  | const pcl::PointCloud< PointT > & | cloud2,
|  | pcl::PointCloud< PointT > & | cloud_out
| ) |  |

inline static

Definition at line 248 of file point_cloud.h.

References pcl::concatenate().

## concatenate() [2/2]

template<typename PointT >

static bool pcl::PointCloud< PointT >::concatenate | ( | pcl::PointCloud< PointT > & | cloud1,
|  | const pcl::PointCloud< PointT > & | cloud2
| ) |  |

inline static

Definition at line 231 of file point_cloud.h.

References pcl::PointCloud< PointT >::begin(), pcl::PointCloud< PointT >::end(), pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::insert(), pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::size(), pcl::PCLHeader::stamp, and pcl::PointCloud< PointT >::width.

Referenced by pcl::concatenate().

## crbegin()

template<typename PointT >

const_reverse_iterator pcl::PointCloud< PointT >::crbegin | ( |  | ) | const

inline noexcept

Definition at line 439 of file point_cloud.h.

## crend()

template<typename PointT >

const_reverse_iterator pcl::PointCloud< PointT >::crend | ( |  | ) | const

inline noexcept

Definition at line 440 of file point_cloud.h.

## data() [1/2]

template<typename PointT >

const PointT* pcl::PointCloud< PointT >::data | ( |  | ) | const

inline noexcept

Definition at line 448 of file point_cloud.h.

## data() [2/2]

template<typename PointT >

PointT* pcl::PointCloud< PointT >::data | ( |  | ) |

inline noexcept

Definition at line 447 of file point_cloud.h.

Referenced by pcl::transformPointCloud().

## emplace()

template<typename PointT >
template<class... Args>

iterator pcl::PointCloud< PointT >::emplace | ( | iterator | position,
|  | Args &&... | args
| ) |  |

inline

Emplace a new point in the cloud, given an iterator.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | iterator before which the point will be emplaced
  [in] | args | the parameters to forward to the point to construct

Returns
  returns the new position iterator

Definition at line 782 of file point_cloud.h.

## emplace_back()

template<typename PointT >
template<class... Args>

reference pcl::PointCloud< PointT >::emplace_back | ( | Args &&... | args | ) |

inline

Emplace a new point in the cloud, at the end of the container.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | args | the parameters to forward to the point to construct

Returns
  reference to the emplaced point

Definition at line 675 of file point_cloud.h.

Referenced by pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures().

## empty()

template<typename PointT >

bool pcl::PointCloud< PointT >::empty | ( |  | ) | const

inline

Definition at line 446 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::applyMorphologicalOperator(), pcl::compute3DCentroid(), pcl::computeCovarianceMatrix(), pcl::computeNDCentroid(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::copyPointCloud(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segmentAndRefine(), pcl::SupervoxelClustering< PointT >::setInputCloud(), pcl::PCDWriter::writeASCII(), pcl::PCDWriter::writeBinary(), and pcl::PCDWriter::writeBinaryCompressed().

## end() [1/2]

template<typename PointT >

const_iterator pcl::PointCloud< PointT >::end | ( |  | ) | const

inline noexcept

Definition at line 432 of file point_cloud.h.

## end() [2/2]

template<typename PointT >

iterator pcl::PointCloud< PointT >::end | ( |  | ) |

inline noexcept

Definition at line 430 of file point_cloud.h.

Referenced by pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::computeCovariances(), pcl::PointCloud< PointT >::concatenate(), pcl::common::deleteRows(), pcl::common::duplicateRows(), pcl::common::expandRows(), pcl::SupervoxelClustering< PointT >::getLabeledCloud(), pcl::SupervoxelClustering< PointT >::getLabeledVoxelCloud(), pcl::common::mirrorRows(), pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), and pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::validateTransformation().

## erase() [1/2]

template<typename PointT >

iterator pcl::PointCloud< PointT >::erase | ( | iterator | first,
|  | iterator | last
| ) |  |

inline

Erase a set of points given by a (first, last) iterator pair.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | first | where to start erasing points from
  [in] | last | where to stop erasing points from

Returns
  returns the new position iterator

Definition at line 836 of file point_cloud.h.

## erase() [2/2]

template<typename PointT >

iterator pcl::PointCloud< PointT >::erase | ( | iterator | position | ) |

inline

Erase a point in the cloud.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | what data point to erase

Returns
  returns the new position iterator

Definition at line 809 of file point_cloud.h.

Referenced by pcl::common::deleteCols(), pcl::common::deleteRows(), and pcl::ConcaveHull< PointInT >::performReconstruction().

## front() [1/2]

template<typename PointT >

PointT& pcl::PointCloud< PointT >::front | ( |  | ) |

inline

Definition at line 536 of file point_cloud.h.

## front() [2/2]

template<typename PointT >

const PointT& pcl::PointCloud< PointT >::front | ( |  | ) | const

inline

Definition at line 535 of file point_cloud.h.

Referenced by pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getEdgeIndex(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getFaceIndex(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getHalfEdgeIndex(), and pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::getVertexIndex().

## getMatrixXfMap() [1/4]

template<typename PointT >

Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( |  | ) |

inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Note
  This method is for advanced users only! Use with care!

Attention
  PointT types are most of the time aligned, so the offsets are not continuous!

Definition at line 374 of file point_cloud.h.

## getMatrixXfMap() [2/4]

template<typename PointT >

const Eigen::Map< Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( |  | ) | const

inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Note
  This method is for advanced users only! Use with care!

Attention
  PointT types are most of the time aligned, so the offsets are not continuous!

Definition at line 386 of file point_cloud.h.

## getMatrixXfMap() [3/4]

template<typename PointT >

Eigen::Map<Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( | int | dim,
|  | int | stride,
|  | int | offset
| ) |  |

inline

Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud.

Note
  This method is for advanced users only! Use with care!

Attention
  Compile time flags used for Eigen might affect the dimension of the Eigen::Map returned. If Eigen is using row major storage, the matrix shape would be (number of Points X elements in a Point) else the matrix shape would be (elements in a Point X number of Points). Essentially,
  - Major direction: number of points in cloud
  - Minor direction: number of point dimensions By default, as of Eigen 3.3, Eigen uses Column major storage

Parameters

  [in] | dim | the number of dimensions to consider for each point
  [in] | stride | the number of values in each point (will be the number of values that separate two of the columns)
  [in] | offset | the number of dimensions to skip from the beginning of each point (stride = offset + dim + x, where x is the number of dimensions to skip from the end of each point)

Note
  for getting only XYZ coordinates out of PointXYZ use dim=3, stride=4 and offset=0 due to the alignment.

Attention
  PointT types are most of the time aligned, so the offsets are not continuous!

Definition at line 333 of file point_cloud.h.

## getMatrixXfMap() [4/4]

template<typename PointT >

const Eigen::Map<const Eigen::MatrixXf, Eigen::Aligned, Eigen::OuterStride<> > pcl::PointCloud< PointT >::getMatrixXfMap | ( | int | dim,
|  | int | stride,
|  | int | offset
| ) |  | const

inline

Return an Eigen MatrixXf (assumes float values) mapped to the specified dimensions of the PointCloud.

Note
  This method is for advanced users only! Use with care!

Attention
  Compile time flags used for Eigen might affect the dimension of the Eigen::Map returned. If Eigen is using row major storage, the matrix shape would be (number of Points X elements in a Point) else the matrix shape would be (elements in a Point X number of Points). Essentially,
  - Major direction: number of points in cloud
  - Minor direction: number of point dimensions By default, as of Eigen 3.3, Eigen uses Column major storage

Parameters

  [in] | dim | the number of dimensions to consider for each point
  [in] | stride | the number of values in each point (will be the number of values that separate two of the columns)
  [in] | offset | the number of dimensions to skip from the beginning of each point (stride = offset + dim + x, where x is the number of dimensions to skip from the end of each point)

Note
  for getting only XYZ coordinates out of PointXYZ use dim=3, stride=4 and offset=0 due to the alignment.

Attention
  PointT types are most of the time aligned, so the offsets are not continuous!

Definition at line 359 of file point_cloud.h.

## insert() [1/3]

template<typename PointT >

iterator pcl::PointCloud< PointT >::insert | ( | iterator | position,
|  | const PointT & | pt
| ) |  |

inline

Insert a new point in the cloud, given an iterator.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | where to insert the point
  [in] | pt | the point to insert

Returns
  returns the new position iterator

Definition at line 702 of file point_cloud.h.

Referenced by pcl::PointCloud< PointT >::concatenate(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), and pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing().

## insert() [2/3]

template<typename PointT >
template<class InputIterator >

void pcl::PointCloud< PointT >::insert | ( | iterator | position,
|  | InputIterator | first,
|  | InputIterator | last
| ) |  |

inline

Insert a new range of points in the cloud, at a certain position.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | where to insert the data
  [in] | first | where to start inserting the points from
  [in] | last | where to stop inserting the points from

Definition at line 756 of file point_cloud.h.

## insert() [3/3]

template<typename PointT >

void pcl::PointCloud< PointT >::insert | ( | iterator | position,
|  | std::size_t | n,
|  | const PointT & | pt
| ) |  |

inline

Insert a new point in the cloud N times, given an iterator.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | position | where to insert the point
  [in] | n | the number of times to insert the point
  [in] | pt | the point to insert

Definition at line 730 of file point_cloud.h.

## isOrganized()

template<typename PointT >

bool pcl::PointCloud< PointT >::isOrganized | ( |  | ) | const

inline

Return whether a dataset is organized (e.g., arranged in a structured grid).

Note
  The height value must be different than 1 for a dataset to be organized.

Definition at line 310 of file point_cloud.h.

Referenced by pcl::visualization::ImageViewer::addMask(), pcl::HypothesisVerification< ModelT, SceneT >::addModels(), pcl::visualization::ImageViewer::addPlanarPolygon(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::ImageViewer::addRectangle(), pcl::common::deleteCols(), pcl::common::duplicateColumns(), pcl::common::expandColumns(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::common::mirrorColumns(), and pcl::PCDGrabber< PointT >::publish().

## makeShared()

template<typename PointT >

Ptr pcl::PointCloud< PointT >::makeShared | ( |  | ) | const

inline

Copy the cloud to the heap and return a smart pointer Note that deep copy is performed, so avoid using this function on non-empty clouds.

The changes of the returned cloud are not mirrored back to this one.

Returns
  shared pointer to the copy of the cloud

Definition at line 887 of file point_cloud.h.

Referenced by pcl::Edge< PointInT, PointOutT >::canny(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::estimateFeatures(), and pcl::Edge< PointInT, PointOutT >::sobelMagnitudeDirection().

## max_size()

template<typename PointT >

index_t pcl::PointCloud< PointT >::max_size | ( |  | ) | const

inline noexcept

Definition at line 444 of file point_cloud.h.

## operator()() [1/2]

template<typename PointT >

PointT& pcl::PointCloud< PointT >::operator() | ( | std::size_t | column,
|  | std::size_t | row
| ) |  |

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 301 of file point_cloud.h.

## operator()() [2/2]

template<typename PointT >

const PointT& pcl::PointCloud< PointT >::operator() | ( | std::size_t | column,
|  | std::size_t | row
| ) |  | const

inline

Obtain the point given by the (column, row) coordinates.

Only works on organized datasets (those that have height != 1).

Parameters

  [in] | column | the column coordinate
  [in] | row | the row coordinate

Definition at line 290 of file point_cloud.h.

## operator+()

template<typename PointT >

PointCloud pcl::PointCloud< PointT >::operator+ | ( | const PointCloud< PointT > & | rhs | ) |

inline

Add a point cloud to another cloud.

Parameters

  [in] | rhs | the cloud to add to the current cloud

Returns
  the new cloud as a concatenation of the current cloud and the new given cloud

Definition at line 225 of file point_cloud.h.

## operator+=()

template<typename PointT >

PointCloud& pcl::PointCloud< PointT >::operator+= | ( | const PointCloud< PointT > & | rhs | ) |

inline

Add a point cloud to the current cloud.

Parameters

  [in] | rhs | the cloud to add to the current cloud

Returns
  the new cloud as a concatenation of the current cloud and the new given cloud

Definition at line 214 of file point_cloud.h.

References pcl::concatenate().

## operator[]() [1/2]

template<typename PointT >

PointT& pcl::PointCloud< PointT >::operator[] | ( | std::size_t | n | ) |

inline

Definition at line 532 of file point_cloud.h.

## operator[]() [2/2]

template<typename PointT >

const PointT& pcl::PointCloud< PointT >::operator[] | ( | std::size_t | n | ) | const

inline

Definition at line 531 of file point_cloud.h.

## push_back()

template<typename PointT >

void pcl::PointCloud< PointT >::push_back | ( | const PointT & | pt | ) |

inline

Insert a new point in the cloud, at the end of the container.

Note
  This breaks the organized structure of the cloud by setting the height to 1!

Parameters

  [in] | pt | the point to insert

Definition at line 652 of file point_cloud.h.

Referenced by pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::addData(), pcl::MovingLeastSquares< PointInT, PointOutT >::addProjectedPointNormal(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::approximatePolygon2D(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::TSDFVolume< VoxelT, WeightT >::convertToTsdfCloud(), pcl::MarchingCubes< PointNT >::createSurface(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::extractEuclideanClusters(), pcl::gpu::extractEuclideanClusters(), pcl::gpu::extractLabeledEuclideanClusters(), pcl::UnaryClassifier< PointT >::getCloudWithLabel(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::PointCloudDepthAndRGBtoXYZRGBA(), pcl::PointCloudRGBtoI(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), and pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track().

## rbegin() [1/2]

template<typename PointT >

const_reverse_iterator pcl::PointCloud< PointT >::rbegin | ( |  | ) | const

inline noexcept

Definition at line 437 of file point_cloud.h.

## rbegin() [2/2]

template<typename PointT >

reverse_iterator pcl::PointCloud< PointT >::rbegin | ( |  | ) |

inline noexcept

Definition at line 435 of file point_cloud.h.

## rend() [1/2]

template<typename PointT >

const_reverse_iterator pcl::PointCloud< PointT >::rend | ( |  | ) | const

inline noexcept

Definition at line 438 of file point_cloud.h.

## rend() [2/2]

template<typename PointT >

reverse_iterator pcl::PointCloud< PointT >::rend | ( |  | ) |

inline noexcept

Definition at line 436 of file point_cloud.h.

## reserve()

template<typename PointT >

void pcl::PointCloud< PointT >::reserve | ( | std::size_t | n | ) |

inline

Definition at line 445 of file point_cloud.h.

Referenced by pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::approximatePolygon2D(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::computeTracking(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::TSDFVolume< VoxelT, WeightT >::convertToTsdfCloud(), pcl::copyPointCloud(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::VoxelGridCovariance< PointT >::getDisplayCloud(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), pcl::transformPointCloud(), and pcl::transformPointCloudWithNormals().

## resize() [1/4]

template<typename PointT >

void pcl::PointCloud< PointT >::resize | ( | index_t | count,
|  | const PointT & | value
| ) |  |

inline

Resizes the container to contain count elements.

- If the current size is greater than `count`, the pointcloud is reduced to its first `count` elements
- If the current size is less than `count`, additional copies of `value` are appended
  Note
    This potentially breaks the organized structure of the cloud by setting the height to 1 IFF `width * height != count`!
  Parameters

    [in] | count | new size of the point cloud
    [in] | value | the value to initialize the new points with

Definition at line 502 of file point_cloud.h.

## resize() [2/4]

template<typename PointT >

void pcl::PointCloud< PointT >::resize | ( | index_t | new_width,
|  | index_t | new_height,
|  | const PointT & | value
| ) |  |

inline

Resizes the container to contain count elements.

- If the current size is greater then the requested size, the pointcloud is reduced to its first requested elements
- If the current size is less then the requested size, additional default-inserted points are appended
  Parameters

    [in] | new_width | new width of the point cloud
    [in] | new_height | new height of the point cloud
    [in] | value | the value to initialize the new points with

Definition at line 523 of file point_cloud.h.

## resize() [3/4]

template<typename PointT >

void pcl::PointCloud< PointT >::resize | ( | std::size_t | count | ) |

inline

Resizes the container to contain `count` elements.

- If the current size is greater than `count`, the pointcloud is reduced to its first `count` elements
- If the current size is less than `count`, additional default-inserted points are appended
  Note
    This potentially breaks the organized structure of the cloud by setting the height to 1 IFF `width * height != count`!
  Parameters

    [in] | count | new size of the point cloud

Definition at line 462 of file point_cloud.h.

Referenced by pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::UniformSampling< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::approximatePolygon(), pcl::Edge< PointInT, PointOutT >::canny(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::cleanUp(), pcl::OrganizedEdgeBase< PointT, PointLT >::compute(), pcl::OrganizedEdgeFromRGB< PointT, PointLT >::compute(), pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::compute(), pcl::OrganizedEdgeFromRGBNormals< PointT, PointNT, PointLT >::compute(), pcl::DisparityMapConverter< PointT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::BRISK2DEstimation< PointInT, PointOutT, KeypointT, IntensityT >::compute(), pcl::features::computeApproximateNormals(), pcl::NormalBasedSignatureEstimation< PointT, PointNT, PointFeature >::computeFeature(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::concatenateFields(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::GaussianKernel::convolveCols(), pcl::GaussianKernel::convolveRows(), pcl::copyPointCloud(), pcl::demeanPointCloud(), pcl::Edge< PointInT, PointOutT >::detectEdgeCanny(), pcl::Edge< PointInT, PointOutT >::detectEdgePrewitt(), pcl::Edge< PointInT, PointOutT >::detectEdgeSobel(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::Morphology< PointT >::dilationBinary(), pcl::Morphology< PointT >::dilationGray(), pcl::Morphology< PointT >::erosionBinary(), pcl::Morphology< PointT >::erosionGray(), pcl::OrganizedEdgeFromRGB< PointT, PointLT >::extractEdges(), pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::extractEdges(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::fromPCLPointCloud2(), pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getFitness(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::Morphology< PointT >::intersectionBinary(), pcl::isPointIn2DPolygon(), pcl::SupervoxelClustering< PointT >::makeSupervoxelNormalCloud(), pcl::search::Search< PointT >::nearestKSearchT(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::Poisson< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::search::Search< PointT >::radiusSearchT(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::ExtractPolygonalPrismData< PointT >::segment(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segment(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segmentAndRefine(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), pcl::Edge< PointInT, PointOutT >::sobelMagnitudeDirection(), pcl::Morphology< PointT >::subtractionBinary(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::Morphology< PointT >::unionBinary(), pcl::registration::TransformationValidationEuclidean< PointSource, PointTarget, Scalar >::validateTransformation(), pcl::io::vtkPolyDataToPointCloud(), and pcl::io::vtkStructuredGridToPointCloud().

## resize() [4/4]

template<typename PointT >

void pcl::PointCloud< PointT >::resize | ( | uindex_t | new_width,
|  | uindex_t | new_height
| ) |  |

inline

Resizes the container to contain `new_width * new_height` elements.

- If the current size is greater than the requested size, the pointcloud is reduced to its first requested elements
- If the current size is less then the requested size, additional default-inserted points are appended
  Parameters

    [in] | new_width | new width of the point cloud
    [in] | new_height | new height of the point cloud

Definition at line 482 of file point_cloud.h.

## size()

template<typename PointT >

std::size_t pcl::PointCloud< PointT >::size | ( |  | ) | const

inline

Definition at line 443 of file point_cloud.h.

Referenced by pcl::visualization::PCLHistogramVisualizer::addFeatureHistogram(), pcl::visualization::PCLPlotter::addFeatureHistogram(), pcl::visualization::ImageViewer::addMask(), pcl::visualization::PCLVisualizer::addPointCloudIntensityGradients(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::PCLVisualizer::addPointCloudPrincipalCurvatures(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::visualization::ImageViewer::addRectangle(), pcl::LineRGBD< PointXYZT, PointRGBT >::addTemplate(), pcl::recognition::TrimmedICP< PointT, Scalar >::align(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::FastBilateralFilterOMP< PointT >::applyFilter(), pcl::SamplingSurfaceNormal< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::UniformSampling< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::applyMorphologicalOperator(), pcl::approximatePolygon(), pcl::approximatePolygon2D(), pcl::UnaryClassifier< PointT >::assignLabels(), pcl::calculatePolygonArea(), pcl::PlaneClipper3D< PointT >::clipPointCloud3D(), pcl::BoxClipper3D< PointT >::clipPointCloud3D(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::BRISK2DEstimation< PointInT, PointOutT, KeypointT, IntensityT >::compute(), pcl::features::computeApproximateCovariances(), pcl::features::computeApproximateNormals(), pcl::computeCovarianceMatrix(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::computeCovariances(), pcl::ESFEstimation< PointInT, PointOutT >::computeESF(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::computeMeanAndCovarianceMatrix(), pcl::computeNDCentroid(), pcl::computePointNormal(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::PointCloud< PointT >::concatenate(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::UnaryClassifier< PointT >::convertCloud(), pcl::gpu::kinfuLS::StandaloneMarchingCubes< PointT >::convertTsdfVectors(), pcl::copyPointCloud(), pcl::detail::copyPointCloudMemcpy(), pcl::LineRGBD< PointXYZT, PointRGBT >::createAndAddTemplate(), pcl::visualization::createPolygon(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::Edge< PointInT, PointOutT >::detectEdgePrewitt(), pcl::Edge< PointInT, PointOutT >::detectEdgeSobel(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::SIFTKeypoint< PointInT, PointOutT >::detectKeypoints(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::registration::TransformationEstimationLM< PointSource, PointTarget, float >::estimateRigidTransformation(), pcl::registration::TransformationEstimation2D< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationDQ< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationPointToPlaneLLSWeighted< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationPointToPlaneWeighted< PointSource, PointTarget, MatScalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimation3Point< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationDualQuaternion< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationLM< PointSource, PointTarget, MatScalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationPointToPlaneLLS< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationSVD< PointSource, PointTarget, float >::estimateRigidTransformation(), pcl::registration::TransformationEstimationSVD< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::registration::TransformationEstimationSymmetricPointToPlaneLLS< PointSource, PointTarget, Scalar >::estimateRigidTransformation(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::extractDescriptors(), pcl::extractEuclideanClusters(), pcl::gpu::extractEuclideanClusters(), pcl::io::PointCloudImageExtractorWithScaling< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromNormalField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromRGBField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromLabelField< PointT >::extractImpl(), pcl::extractLabeledEuclideanClusters(), pcl::gpu::extractLabeledEuclideanClusters(), pcl::occlusion_reasoning::ZBuffering< ModelT, SceneT >::filter(), pcl::occlusion_reasoning::filter(), pcl::CVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::findObjects(), pcl::PCDWriter::generateHeader(), pcl::getApproximateIndices(), pcl::UnaryClassifier< PointT >::getCloudWithLabel(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::getFitness(), pcl::getMaxDistance(), pcl::getMaxSegment(), pcl::getMeanPointDensity(), pcl::occlusion_reasoning::getOccludedCloud(), pcl::getPointCloudDifference(), pcl::getPointsInBox(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::Morphology< PointT >::intersectionBinary(), pcl::isPointIn2DPolygon(), pcl::isXYPointIn2DXYPolygon(), pcl::UnaryClassifier< PointT >::kmeansClustering(), pcl::LineRGBD< PointXYZT, PointRGBT >::loadTemplates(), pcl::VoxelGridCovariance< PointT >::nearestKSearch(), pcl::KdTree< PointT >::nearestKSearch(), pcl::search::Search< PointT >::nearestKSearchT(), pcl::operator<<(), pcl::MovingLeastSquares< PointInT, PointOutT >::performProcessing(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::PointCloud< PointT >::PointCloud(), pcl::io::pointCloudTovtkPolyData(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::UnaryClassifier< PointT >::queryFeatureDistances(), pcl::search::Search< PointT >::radiusSearch(), pcl::KdTree< PointT >::radiusSearch(), pcl::VoxelGridCovariance< PointT >::radiusSearch(), pcl::search::Search< PointT >::radiusSearchT(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::search::Search< PointInT >::Search(), pcl::seededHueSegmentation(), pcl::ExtractPolygonalPrismData< PointT >::segment(), pcl::SampleConsensusPrerejective< PointSource, PointTarget, FeatureT >::selectSamples(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::setEdgeDataCloud(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::setFaceDataCloud(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::setHalfEdgeDataCloud(), pcl::GeneralizedIterativeClosestPoint< PointSource, PointTarget >::setInputSource(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::setPointsToTrack(), pcl::poisson::Octree< Degree >::setTree(), pcl::geometry::MeshBase< DerivedT, MeshTraitsT, MeshTagT >::setVertexDataCloud(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::simplifyCloud(), pcl::Edge< PointInT, PointOutT >::sobelMagnitudeDirection(), pcl::Morphology< PointT >::subtractionBinary(), pcl::toPCLPointCloud2(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::Morphology< PointT >::unionBinary(), pcl::visualization::PCLHistogramVisualizer::updateFeatureHistogram(), pcl::visualization::PCLVisualizer::updatePolygonMesh(), pcl::registration::KFPCSInitialAlignment< PointSource, PointTarget, NormalT, Scalar >::validateTransformation(), pcl::io::vtkPolyDataToPointCloud(), pcl::PCDWriter::writeASCII(), pcl::PCDWriter::writeBinary(), and pcl::PCDWriter::writeBinaryCompressed().

## swap()

template<typename PointT >

void pcl::PointCloud< PointT >::swap | ( | PointCloud< PointT > & | rhs | ) |

inline

Swap a point cloud with another cloud.

Parameters

  [in,out] | rhs | point cloud to swap this with

Definition at line 861 of file point_cloud.h.

References pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::is_dense, pcl::PointCloud< PointT >::points, pcl::PointCloud< PointT >::sensor_orientation_, pcl::PointCloud< PointT >::sensor_origin_, and pcl::PointCloud< PointT >::width.

Referenced by pcl::applyMorphologicalOperator(), and pcl::MarchingCubes< PointNT >::performReconstruction().

## transient_emplace()

template<typename PointT >
template<class... Args>

iterator pcl::PointCloud< PointT >::transient_emplace | ( | iterator | position,
|  | Args &&... | args
| ) |  |

inline

Emplace a new point in the cloud, given an iterator.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | position | iterator before which the point will be emplaced
  [in] | args | the parameters to forward to the point to construct

Returns
  returns the new position iterator

Definition at line 797 of file point_cloud.h.

## transient_emplace_back()

template<typename PointT >
template<class... Args>

reference pcl::PointCloud< PointT >::transient_emplace_back | ( | Args &&... | args | ) |

inline

Emplace a new point in the cloud, at the end of the container.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | args | the parameters to forward to the point to construct

Returns
  reference to the emplaced point

Definition at line 689 of file point_cloud.h.

## transient_erase() [1/2]

template<typename PointT >

iterator pcl::PointCloud< PointT >::transient_erase | ( | iterator | first,
|  | iterator | last
| ) |  |

inline

Erase a set of points given by a (first, last) iterator pair.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | first | where to start erasing points from
  [in] | last | where to stop erasing points from

Returns
  returns the new position iterator

Definition at line 851 of file point_cloud.h.

## transient_erase() [2/2]

template<typename PointT >

iterator pcl::PointCloud< PointT >::transient_erase | ( | iterator | position | ) |

inline

Erase a point in the cloud.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | position | what data point to erase

Returns
  returns the new position iterator

Definition at line 823 of file point_cloud.h.

## transient_insert() [1/3]

template<typename PointT >

iterator pcl::PointCloud< PointT >::transient_insert | ( | iterator | position,
|  | const PointT & | pt
| ) |  |

inline

Insert a new point in the cloud, given an iterator.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | position | where to insert the point
  [in] | pt | the point to insert

Returns
  returns the new position iterator

Definition at line 717 of file point_cloud.h.

## transient_insert() [2/3]

template<typename PointT >
template<class InputIterator >

void pcl::PointCloud< PointT >::transient_insert | ( | iterator | position,
|  | InputIterator | first,
|  | InputIterator | last
| ) |  |

inline

Insert a new range of points in the cloud, at a certain position.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | position | where to insert the data
  [in] | first | where to start inserting the points from
  [in] | last | where to stop inserting the points from

Definition at line 770 of file point_cloud.h.

## transient_insert() [3/3]

template<typename PointT >

void pcl::PointCloud< PointT >::transient_insert | ( | iterator | position,
|  | std::size_t | n,
|  | const PointT & | pt
| ) |  |

inline

Insert a new point in the cloud N times, given an iterator.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | position | where to insert the point
  [in] | n | the number of times to insert the point
  [in] | pt | the point to insert

Definition at line 744 of file point_cloud.h.

## transient_push_back()

template<typename PointT >

void pcl::PointCloud< PointT >::transient_push_back | ( | const PointT & | pt | ) |

inline

Insert a new point in the cloud, at the end of the container.

Note
  This assumes the user would correct the width and height later on!

Parameters

  [in] | pt | the point to insert

Definition at line 664 of file point_cloud.h.

Referenced by pcl::copyPointCloud().

## Member Data Documentation

## header

template<typename PointT >

pcl::PCLHeader pcl::PointCloud< PointT >::header

The point cloud header.

It contains information about the acquisition time.

Definition at line 392 of file point_cloud.h.

Referenced by pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::features::computeApproximateNormals(), pcl::PointCloud< PointT >::concatenate(), pcl::concatenateFields(), pcl::copyPointCloud(), pcl::demeanPointCloud(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::extractEuclideanClusters(), pcl::gpu::extractEuclideanClusters(), pcl::extractLabeledEuclideanClusters(), pcl::gpu::extractLabeledEuclideanClusters(), pcl::Filter< PointT >::filter(), pcl::fromPCLPointCloud2(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::SegmentDifferences< PointT >::segment(), pcl::PointCloud< PointT >::swap(), pcl::toPCLPointCloud2(), pcl::transformPointCloud(), and pcl::transformPointCloudWithNormals().

## height

template<typename PointT >

std::uint32_t pcl::PointCloud< PointT >::height = 0

The point cloud height (if organized as an image-structure).

Definition at line 400 of file point_cloud.h.

Referenced by pcl::visualization::ImageViewer::addMask(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::ImageViewer::addRectangle(), pcl::visualization::ImageViewer::addRGBImage(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::MedianFilter< PointT >::applyFilter(), pcl::ProjectInliers< PointT >::applyFilter(), pcl::SamplingSurfaceNormal< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::UniformSampling< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::LineRGBD< PointXYZT, PointRGBT >::applyProjectiveDepthICPOnDetections(), pcl::Edge< PointInT, PointOutT >::canny(), pcl::OrganizedEdgeBase< PointT, PointLT >::compute(), pcl::OrganizedEdgeFromRGB< PointT, PointLT >::compute(), pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::compute(), pcl::OrganizedEdgeFromRGBNormals< PointT, PointNT, PointLT >::compute(), pcl::DisparityMapConverter< PointT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::BRISK2DEstimation< PointInT, PointOutT, KeypointT, IntensityT >::compute(), pcl::filters::Pyramid< PointT >::compute(), pcl::features::computeApproximateNormals(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradients(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradientsSobel(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::PointCloud< PointT >::concatenate(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::UnaryClassifier< PointT >::convertCloud(), pcl::gpu::kinfuLS::StandaloneMarchingCubes< PointT >::convertTrianglesToMesh(), pcl::GaussianKernel::convolve(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::GaussianKernel::convolveCols(), pcl::GaussianKernel::convolveRows(), pcl::copyPointCloud(), pcl::common::deleteCols(), pcl::common::deleteRows(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::Edge< ImageType, ImageType >::detectEdgeCanny(), pcl::Edge< PointInT, PointOutT >::detectEdgeCanny(), pcl::Edge< PointInT, PointOutT >::detectEdgePrewitt(), pcl::Edge< ImageType, ImageType >::detectEdgeRoberts(), pcl::Edge< PointInT, PointOutT >::detectEdgeSobel(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::Morphology< PointT >::dilationBinary(), pcl::Morphology< PointT >::dilationGray(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::downsample(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::Morphology< PointT >::erosionBinary(), pcl::Morphology< PointT >::erosionGray(), pcl::estimateProjectionMatrix(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::OrganizedEdgeFromRGB< PointT, PointLT >::extractEdges(), pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::extractEdges(), pcl::io::PointCloudImageExtractorWithScaling< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromNormalField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromRGBField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromLabelField< PointT >::extractImpl(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::extractRGBFromPointCloud(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::occlusion_reasoning::filter(), pcl::fromPCLPointCloud2(), pcl::PCDWriter::generateHeader(), pcl::UnaryClassifier< PointT >::getCloudWithLabel(), pcl::MinCutSegmentation< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::occlusion_reasoning::getOccludedCloud(), pcl::RFFaceDetectorTrainer::getVotes(), pcl::RFFaceDetectorTrainer::getVotes2(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::Morphology< PointT >::intersectionBinary(), pcl::UnaryClassifier< PointT >::kmeansClustering(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::PointCloudDepthAndRGBtoXYZRGBA(), pcl::PointCloudRGBtoI(), pcl::io::pointCloudTovtkStructuredGrid(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::PCDGrabber< PointT >::publish(), pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::queryBBIncludes(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::SegmentDifferences< PointT >::segment(), pcl::visualization::ImageViewer::showCorrespondences(), pcl::Edge< PointInT, PointOutT >::sobelMagnitudeDirection(), pcl::Morphology< PointT >::subtractionBinary(), pcl::PointCloud< PointT >::swap(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::swapDimensions(), pcl::toPCLPointCloud2(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::Morphology< PointT >::unionBinary(), pcl::io::vtkPolyDataToPointCloud(), pcl::io::vtkStructuredGridToPointCloud(), and pcl::PCDWriter::writeASCII().

## is_dense

template<typename PointT >

bool pcl::PointCloud< PointT >::is_dense = true

True if no points are invalid (e.g., have NaN or Inf values in any of their floating point fields).

Definition at line 403 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::ExtractIndices< PointT >::applyFilter(), pcl::FilterIndices< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::UniformSampling< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::BRISK2DEstimation< PointInT, PointOutT, KeypointT, IntensityT >::compute(), pcl::compute3DCentroid(), pcl::computeCentroid(), pcl::computeCovarianceMatrix(), pcl::SHOTEstimation< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::SHOTColorEstimation< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::FPFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntensityGradientEstimation< PointInT, PointNT, PointOutT, IntensitySelectorT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computeFeature(), pcl::NormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::PFHEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::PrincipalCurvaturesEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::SHOTEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::SHOTColorEstimationOMP< PointInT, PointNT, PointOutT, PointRFT >::computeFeature(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeatureFull(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeaturePart(), pcl::computeMeanAndCovarianceMatrix(), pcl::PointCloud< PointT >::concatenate(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::UnaryClassifier< PointT >::convertCloud(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::copyPointCloud(), pcl::demeanPointCloud(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::fromPCLPointCloud2(), pcl::UnaryClassifier< PointT >::getCloudWithLabel(), pcl::MinCutSegmentation< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::getMaxDistance(), pcl::getMinMax3D(), pcl::getPointCloudDifference(), pcl::getPointsInBox(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::UnaryClassifier< PointT >::kmeansClustering(), pcl::operator<<(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::io::pointCloudTovtkPolyData(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::PointCloud< PointT >::swap(), pcl::toPCLPointCloud2(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::visualization::PCLVisualizer::updatePolygonMesh(), pcl::io::vtkPolyDataToPointCloud(), and pcl::io::vtkStructuredGridToPointCloud().

## points

template<typename PointT >

std::vector<PointT, Eigen::aligned_allocator<PointT> > pcl::PointCloud< PointT >::points

The point data.

Definition at line 395 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::features::computeApproximateCovariances(), pcl::features::computeApproximateNormals(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::MomentInvariantsEstimation< PointInT, PointOutT >::computePointMomentInvariants(), pcl::UnaryClassifier< PointT >::convertCloud(), pcl::gpu::kinfuLS::StandaloneMarchingCubes< PointT >::convertTrianglesToMesh(), pcl::visualization::createPolygon(), pcl::HarrisKeypoint6D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::BriskKeypoint2D< PointInT, PointOutT, IntensityT >::detectKeypoints(), pcl::HarrisKeypoint3D< PointInT, PointOutT, NormalT >::detectKeypoints(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::extractDescriptors(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::extractRGBFromPointCloud(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::findObjects(), pcl::MinCutSegmentation< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::getMinMax3D(), pcl::RFFaceDetectorTrainer::getVotes(), pcl::RFFaceDetectorTrainer::getVotes2(), pcl::UnaryClassifier< PointT >::kmeansClustering(), pcl::MarchingCubes< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::PointCloudRGBtoI(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::OrganizedMultiPlaneSegmentation< PointT, PointNT, PointLT >::segmentAndRefine(), pcl::PlanarPolygon< PointT >::setContour(), pcl::ism::ImplicitShapeModelEstimation< FeatureSize, PointT, NormalT >::shiftCloud(), pcl::TextureMapping< PointInT >::showOcclusions(), pcl::PointCloud< PointT >::swap(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::swapDimensions(), and pcl::TextureMapping< PointInT >::textureMeshwithMultipleCameras().

## sensor_orientation_

template<typename PointT >

Eigen::Quaternionf pcl::PointCloud< PointT >::sensor_orientation_ = Eigen::Quaternionf::Identity ()

Sensor acquisition pose (rotation).

Definition at line 408 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addCorrespondences(), pcl::visualization::PCLVisualizer::addPointCloud(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::copyPointCloud(), pcl::Filter< PointT >::filter(), pcl::PCDWriter::generateHeader(), pcl::operator<<(), pcl::ImageGrabber< PointT >::operator[](), pcl::PCDGrabber< PointT >::operator[](), pcl::ImageGrabber< PointT >::publish(), pcl::StereoGrabber< PointT >::publish(), pcl::PCDGrabber< PointT >::publish(), pcl::IFSReader::read(), pcl::FileReader::read(), pcl::OBJReader::read(), pcl::PCDReader::read(), pcl::PLYReader::read(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::PointCloud< PointT >::swap(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::PLYWriter::write(), and pcl::FileWriter::write().

## sensor_origin_

template<typename PointT >

Eigen::Vector4f pcl::PointCloud< PointT >::sensor_origin_ = Eigen::Vector4f::Zero ()

Sensor acquisition pose (origin/translation).

Definition at line 406 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addCorrespondences(), pcl::visualization::PCLVisualizer::addPointCloud(), pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::PCLVisualizer::addPolygonMesh(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeature(), pcl::copyPointCloud(), pcl::Filter< PointT >::filter(), pcl::PCDWriter::generateHeader(), pcl::operator<<(), pcl::ImageGrabber< PointT >::operator[](), pcl::PCDGrabber< PointT >::operator[](), pcl::ImageGrabber< PointT >::publish(), pcl::StereoGrabber< PointT >::publish(), pcl::PCDGrabber< PointT >::publish(), pcl::IFSReader::read(), pcl::FileReader::read(), pcl::OBJReader::read(), pcl::PCDReader::read(), pcl::PLYReader::read(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::PointCloud< PointT >::swap(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::PLYWriter::write(), and pcl::FileWriter::write().

## width

template<typename PointT >

std::uint32_t pcl::PointCloud< PointT >::width = 0

The point cloud width (if organized as an image-structure).

Definition at line 398 of file point_cloud.h.

Referenced by pcl::visualization::PCLVisualizer::addPointCloudNormals(), pcl::visualization::ImageViewer::addRGBImage(), pcl::Registration< PointSource, PointTarget, Scalar >::align(), pcl::ApproximateVoxelGrid< PointT >::applyFilter(), pcl::ConditionalRemoval< PointT >::applyFilter(), pcl::GridMinimum< PointT >::applyFilter(), pcl::LocalMaximum< PointT >::applyFilter(), pcl::MedianFilter< PointT >::applyFilter(), pcl::ProjectInliers< PointT >::applyFilter(), pcl::SamplingSurfaceNormal< PointT >::applyFilter(), pcl::ShadowPoints< PointT, NormalT >::applyFilter(), pcl::UniformSampling< PointT >::applyFilter(), pcl::VoxelGrid< PointT >::applyFilter(), pcl::VoxelGridCovariance< PointT >::applyFilter(), pcl::LineRGBD< PointXYZT, PointRGBT >::applyProjectiveDepthICPOnDetections(), pcl::RangeImageBorderExtractor::calculateBorderDirection(), pcl::RangeImageBorderExtractor::calculateMainPrincipalCurvature(), pcl::Edge< PointInT, PointOutT >::canny(), pcl::RangeImageBorderExtractor::changeScoreAccordingToShadowBorderValue(), pcl::RangeImageBorderExtractor::checkIfMaximum(), pcl::RangeImageBorderExtractor::checkPotentialBorder(), pcl::OrganizedEdgeBase< PointT, PointLT >::compute(), pcl::OrganizedEdgeFromRGB< PointT, PointLT >::compute(), pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::compute(), pcl::OrganizedEdgeFromRGBNormals< PointT, PointNT, PointLT >::compute(), pcl::DisparityMapConverter< PointT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::compute(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::BRISK2DEstimation< PointInT, PointOutT, KeypointT, IntensityT >::compute(), pcl::filters::Pyramid< PointT >::compute(), pcl::features::computeApproximateNormals(), pcl::GFPFHEstimation< PointInT, PointLT, PointOutT >::computeFeature(), pcl::GRSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntensitySpinEstimation< PointInT, PointOutT >::computeFeature(), pcl::RIFTEstimation< PointInT, GradientT, PointOutT >::computeFeature(), pcl::RSDEstimation< PointInT, PointNT, PointOutT >::computeFeature(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeatureFull(), pcl::IntegralImageNormalEstimation< PointInT, PointOutT >::computeFeaturePart(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradients(), pcl::ColorGradientModality< PointInT >::computeMaxColorGradientsSobel(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::LineRGBD< PointXYZT, PointRGBT >::computeTransformedTemplatePoints(), pcl::PointCloud< PointT >::concatenate(), pcl::concatenateFields(), pcl::io::OrganizedConversion< PointT, false >::convert(), pcl::io::OrganizedConversion< PointT, true >::convert(), pcl::UnaryClassifier< PointT >::convertCloud(), pcl::gpu::kinfuLS::StandaloneMarchingCubes< PointT >::convertTrianglesToMesh(), pcl::GaussianKernel::convolve(), pcl::filters::Convolution3D< PointIn, PointOut, KernelT >::convolve(), pcl::GaussianKernel::convolveCols(), pcl::GaussianKernel::convolveRows(), pcl::copyPointCloud(), pcl::common::deleteCols(), pcl::common::deleteRows(), pcl::demeanPointCloud(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::derivatives(), pcl::Edge< ImageType, ImageType >::detectEdgeCanny(), pcl::Edge< PointInT, PointOutT >::detectEdgeCanny(), pcl::Edge< PointInT, PointOutT >::detectEdgePrewitt(), pcl::Edge< ImageType, ImageType >::detectEdgeRoberts(), pcl::Edge< PointInT, PointOutT >::detectEdgeSobel(), pcl::SUSANKeypoint< PointInT, PointOutT, NormalT, IntensityT >::detectKeypoints(), pcl::SmoothedSurfacesKeypoint< PointT, PointNT >::detectKeypoints(), pcl::MultiscaleFeaturePersistence< PointSource, PointFeature >::determinePersistentFeatures(), pcl::Morphology< PointT >::dilationBinary(), pcl::Morphology< PointT >::dilationGray(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::downsample(), pcl::common::duplicateColumns(), pcl::common::duplicateRows(), pcl::Morphology< PointT >::erosionBinary(), pcl::Morphology< PointT >::erosionGray(), pcl::estimateProjectionMatrix(), pcl::common::expandColumns(), pcl::common::expandRows(), pcl::io::PointCloudImageExtractor< PointT >::extract(), pcl::OrganizedEdgeBase< PointT, PointLT >::extractEdges(), pcl::OrganizedEdgeFromRGB< PointT, PointLT >::extractEdges(), pcl::OrganizedEdgeFromNormals< PointT, PointNT, PointLT >::extractEdges(), pcl::io::PointCloudImageExtractorWithScaling< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromNormalField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromRGBField< PointT >::extractImpl(), pcl::io::PointCloudImageExtractorFromLabelField< PointT >::extractImpl(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::extractRGBFromPointCloud(), pcl::common::CloudGenerator< pcl::PointXY, GeneratorT >::fill(), pcl::common::CloudGenerator< PointT, GeneratorT >::fill(), pcl::occlusion_reasoning::filter(), pcl::fromPCLPointCloud2(), pcl::PCDWriter::generateHeader(), pcl::UnaryClassifier< PointT >::getCloudWithLabel(), pcl::MinCutSegmentation< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloud(), pcl::features::ISMVoteList< PointT >::getColoredCloud(), pcl::RegionGrowing< PointT, NormalT >::getColoredCloudRGBA(), pcl::occlusion_reasoning::getOccludedCloud(), pcl::RFFaceDetectorTrainer::getVotes(), pcl::RFFaceDetectorTrainer::getVotes2(), pcl::filters::Convolution< PointIn, PointOut >::initCompute(), pcl::outofcore::OutofcoreOctreeDiskContainer< PointT >::insertRange(), pcl::Morphology< PointT >::intersectionBinary(), pcl::UnaryClassifier< PointT >::kmeansClustering(), pcl::common::mirrorColumns(), pcl::common::mirrorRows(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::mismatchVector(), pcl::operator<<(), pcl::BilateralUpsampling< PointInT, PointOutT >::performProcessing(), pcl::GridProjection< PointNT >::performReconstruction(), pcl::ConcaveHull< PointInT >::performReconstruction(), pcl::ConvexHull< PointInT >::performReconstruction2D(), pcl::ConvexHull< PointInT >::performReconstruction3D(), pcl::PointCloudDepthAndRGBtoXYZRGBA(), pcl::PointCloudRGBtoI(), pcl::io::pointCloudTovtkStructuredGrid(), pcl::PointCloudXYZRGBAtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZHSV(), pcl::PointCloudXYZRGBtoXYZI(), pcl::CloudSurfaceProcessing< PointInT, PointOutT >::process(), pcl::BilateralUpsampling< PointInT, PointOutT >::process(), pcl::MovingLeastSquares< PointInT, PointOutT >::process(), pcl::ColorGradientModality< PointInT >::processInputData(), pcl::SampleConsensusModelCircle2D< PointT >::projectPoints(), pcl::SampleConsensusModelCircle3D< PointT >::projectPoints(), pcl::SampleConsensusModelCone< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelCylinder< PointT, PointNT >::projectPoints(), pcl::SampleConsensusModelLine< PointT >::projectPoints(), pcl::SampleConsensusModelPlane< PointT >::projectPoints(), pcl::SampleConsensusModelSphere< PointT >::projectPoints(), pcl::SampleConsensusModelStick< PointT >::projectPoints(), pcl::PCDGrabber< PointT >::publish(), pcl::outofcore::OutofcoreOctreeBaseNode< ContainerT, PointT >::queryBBIncludes(), pcl::io::LZFDepth16ImageReader::read(), pcl::io::LZFRGB24ImageReader::read(), pcl::io::LZFYUV422ImageReader::read(), pcl::io::LZFBayer8ImageReader::read(), pcl::io::LZFDepth16ImageReader::readOMP(), pcl::io::LZFRGB24ImageReader::readOMP(), pcl::io::LZFYUV422ImageReader::readOMP(), pcl::io::LZFBayer8ImageReader::readOMP(), pcl::SurfaceReconstruction< PointInT >::reconstruct(), pcl::ConcaveHull< PointInT >::reconstruct(), pcl::ConvexHull< PointInT >::reconstruct(), pcl::removeNaNFromPointCloud(), pcl::removeNaNNormalsFromPointCloud(), pcl::OrganizedConnectedComponentSegmentation< PointT, PointLT >::segment(), pcl::SegmentDifferences< PointT >::segment(), pcl::visualization::ImageViewer::showCorrespondences(), pcl::Edge< PointInT, PointOutT >::sobelMagnitudeDirection(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::spatialGradient(), pcl::Morphology< PointT >::subtractionBinary(), pcl::PointCloud< PointT >::swap(), pcl::people::GroundBasedPeopleDetectionApp< PointT >::swapDimensions(), pcl::toPCLPointCloud2(), pcl::tracking::PyramidalKLTTracker< PointInT, IntensityT >::track(), pcl::transformPointCloud(), pcl::transformPointCloudWithNormals(), pcl::Morphology< PointT >::unionBinary(), pcl::RangeImageBorderExtractor::updatedScoreAccordingToNeighborValues(), pcl::io::vtkPolyDataToPointCloud(), pcl::io::vtkStructuredGridToPointCloud(), and pcl::PCDWriter::writeASCII().

The documentation for this class was generated from the following files:

- pcl/common/distances.h
- pcl/point_cloud.h